pub fn process_part1(input: &str) -> i32 {
    let mut marker = "".to_string();
    for (idx, c) in input.chars().enumerate() {
        if marker.len() == 4 {
            return (idx).try_into().unwrap();
        }
        if let Some(c_pos) = marker.find(c) {
            let (_, new_marker) = marker.split_at(c_pos + 1);
            marker = new_marker.to_string();
        }
        marker.push(c);
    }
    0
}

pub fn process_part2(input: &str) -> i32 {
    let mut marker = "".to_string();
    for (idx, c) in input.chars().enumerate() {
        if marker.len() == 14 {
            return (idx).try_into().unwrap();
        }
        if let Some(c_pos) = marker.find(c) {
            let (_, new_marker) = marker.split_at(c_pos + 1);
            marker = new_marker.to_string();
        }
        marker.push(c);
    }
    0
}

#[cfg(test)]
mod tests {
    use super::*;

    const INPUT1: &str = "mjqjpqmgbljsphdztnvjfqwrcgsmlb";
    const INPUT2: &str = "bvwbjplbgvbhsrlpgdmjqwftvncz";
    const INPUT3: &str = "nppdvjthqldpwncqszvftbrmjlhg";
    const INPUT4: &str = "nznrnfrfntjfmvfwmzdfjlvtqnbhcprsg";
    const INPUT5: &str = "zcfzfwzzqfrljwzlrfnpqdbhtmscgvjw";

    #[test]
    fn part1() {
        let result = process_part1(INPUT1);
        assert_eq!(result, 7);
        let result = process_part1(INPUT2);
        assert_eq!(result, 5);
        let result = process_part1(INPUT3);
        assert_eq!(result, 6);
        let result = process_part1(INPUT4);
        assert_eq!(result, 10);
        let result = process_part1(INPUT5);
        assert_eq!(result, 11);
    }

    #[test]
    fn part2() {
        let result = process_part2(INPUT1);
        assert_eq!(result, 19);
        let result = process_part2(INPUT2);
        assert_eq!(result, 23);
        let result = process_part2(INPUT3);
        assert_eq!(result, 23);
        let result = process_part2(INPUT4);
        assert_eq!(result, 29);
        let result = process_part2(INPUT5);
        assert_eq!(result, 26);
    }
}
